#include <stdio.h>
#include <Xm/Xm.h>

#include "defines.h"
#include "types.h"

/* returns 1 if box1 and box2 overlap */

int sbox_overlap (SBOX *box1, SBOX*box2)
{
  if ((int)(box1->x+box1->width) < box2->x)
    return (int)0;
  if ((int)(box2->x+box2->width) < box1->x)
    return (int)0;
  if ((int)(box1->y+box1->height) < box2->y)
    return (int)0;
  if ((int)(box2->y+box2->height) < box1->y)
    return (int)0;
  return (int)1;
}


/* box1 will be the box surrounding both boxes */
void update_sbox (SBOX *box1, SBOX *box2)
{
  if (box1->width == -1) {
    box1->x = box2->x;
    box1->y = box2->y;
    box1->width = box2->width;
    box1->height = box2->height;
  }
  else {
    box1->width = MAX (box1->x + box1->width, box2->x + box2->width);
    box1->height = MAX (box1->y + box1->height, box2->y + box2->height);
    box1->x = MIN (box1->x, box2->x);
    box1->y = MIN (box1->y, box2->y);
    box1->width -= box1->x;
    box1->height -= box1->y;
  }
}
