#include <stdio.h>
#include <Xm/Xm.h>

#include "defines.h"
#include "types.h"
#include "globals.h"
#include "alloc.h"

void init_color_table (Display *display)
{
  int screen = DefaultScreen (display);
  int cells = DisplayCells (display, screen);

  coltable = CALLOC_ARRAY (cells, XColor);
  nilpixel = cells;
}


int pixel_to_rgb (Display *display, Pixel pixel, XColor *rgb)
{
  int screen = DefaultScreen (display);
  Colormap cm = XDefaultColormap (display, screen);
  int status;
  
  rgb->pixel = pixel;
  status = XQueryColor (display, cm, rgb);
  if (status == BadColor) {
    fprintf (stderr, "XQueryColor: Bad Color\n");
    return -1;
  }
  if (status == BadValue) {
    fprintf (stderr, "XQueryColor: Bad Value\n");
    return -1;
  }

  return 0;
}

