/* 
 * file-documentation
 * =========================================================================
 * rubband.c -- 
 * 
 * Author          : Hans Fleurkens
 * Created On      : Tue Jan 28 15:24:14 1992
 * Last Modified By: Hans Fleurkens
 * Last Modified On: Tue Sep 28 09:29:36 1993
 * Update Count    : 2
 * Status          : none
 * 
 * History
 * Description:
 * 	>
 * =========================================================================
 * Copyright (c) 1992-1993
 * All Rights Reserved
 * Hans Fleurkens
 * Eindhoven University of Technology
 * The Netherlands
 * =========================================================================
 */

#include <stdio.h>
#include <Xm/Xm.h>

#include "defines.h"
#include "types.h"
#include "globals.h"

extern GC rubbergc;

static void draw_box (GC gc, CBOX *box)
{
  int min_x, min_y, width, height;

  min_x = MIN (box->x1, box->x2);
  min_y = MIN (box->y1, box->y2);
  width = ABS (box->x1 - box->x2);
  height = ABS (box->y1 - box->y2);

  XDrawRectangle (XtDisplay(canvas), XtWindow(canvas), gc,
		  min_x, min_y, width, height);
}


/* XtEventHandler */
void press_rubband_box (Widget w,
			XtPointer client_data,
			XButtonEvent *event,
			Boolean *cont_to_disp)
{
  if (event->button != Button1)
    return;

  rubboxdata.x1 = event->x;
  rubboxdata.y1 = event->y;
  rubboxdata.x2 = event->x;
  rubboxdata.y2 = event->y;

  draw_box (rubbergc, &rubboxdata);
}


/* XtEventHandler */
void track_rubband_box (Widget w,
			XtPointer client_data,
			XButtonEvent *event,
			Boolean *cont_to_disp)
{
  if ((event->state & Button1Mask) == 0) {
    return;
  }
  draw_box (rubbergc, &rubboxdata);
  rubboxdata.x2 = event->x;
  rubboxdata.y2 = event->y;
  draw_box (rubbergc, &rubboxdata);
}


/* XtEventHandler */
void release_rubband_box (Widget w,
			  XtPointer client_data,
			  XButtonEvent *event,
			  Boolean *cont_to_disp)
{
  if (event->button != Button1)
    return;

  draw_box (rubbergc, &rubboxdata);
  
  rubboxdata.x2 = event->x;
  rubboxdata.y2 = event->y;
}

